FlatCAM: 2D Computer-Aided PCB Manufacturing
============================================

Quickstart
=========

On OSX:

```bash
	brew install tcl-tk spatialindex pyqt5
	pip install flatcam
```

On Windows/Linux: Contribute a CI/CD fix for that, manually crafted releases not accepted nor trusted here!


Why a FlatCAM fork?
===================

This is a **temporary** fork of [FlatCAM upstream](https://bitbucket.org/jpcgt/flatcam) development which supports:

	* Python3
	* PyQt5
	* Proper CI/CD and pythonic, modern [project structure](http://docs.python-guide.org/en/latest/writing/structure/).
	* Semver, PEP440 and other good development and release engineering practices.
	* Pypi-installable package: `pip install flatcam` (assuming system packages installed as shown above in Quickstart)

At the time of writing this, there are a few broken tests that need to be fixed, but overall the port [(and pullrequest)](https://bitbucket.org/jpcgt/flatcam/pull-requests/75) works for me on a day-to-day basis for several months of happy PCB milling.

Broken tests do not reflect broken functionality at the moment, perhaps indicative of broken testsuite and coverage?:

```bash
$ python -m unittest discover
(...)
----------------------------------------------------------------------
Ran 47 tests in 19.138s

OK
```

If you happen to have the time, please have a look at the problematic tests, rename the prefix to `test_*` instead of `notest_*`:

```bash
$ find . -iname "notest*.py"
./tests/notest_gerber_flow.py
./tests/notest_polygon_paint.py
./tests/notest_tcl_shell.py
./tests/toolpath_optimization_profiling/notest_toollift_minimization_profile1.py
```

The main reason for this (hopefully temporal) fork is the drive of other developers to stay with PyQt4 and work individually instead of together in order to modernize FlatCAM as it deserves. The sizeable changeset in the above pullrequest seems to be a deterrent to work together on the same goal.

Since the upstream momentum seems to be mainly individual-focused instead of collaborative development, I've decided to push this fork as a protest and service to the FlatCAM community before the above pullrequest dies off because of repeated PyQt4 merge conflicts introduced by third party developers. Also as a selfish need to have an easy, functional, OSX-supported pip-installable FlatCAM package (not available in upstream right now).

Please feel free to file pullrequests and issues on my [repository and branches](https://bitbucket.org/brainstorm/flatcam/src). I will sparingly keep merging updates from upstream and pushing releases to PyPi as I see fit, although the current focus and irrational investment on PyQt4 might hinder those efforts over time.

I am willing to have my changes merged upstream as well as sharing PyPi access to this project, but I would prefer for third party users and developers to test it thoroughly and file pullrequests addressing the (few) defficiencies left to fix.


(c) 2014-2018 Juan Pablo Caram

FlatCAM is a program for preparing CNC jobs for making PCBs on a CNC router.
Among other things, it can take a Gerber file generated by your favorite PCB
CAD program, and create G-Code for Isolation routing.
